/*
 *	Copyright (C) 2007, 2008. PARP Research Group.
 *	<http://perception.inf.um.es>
 *	University of Murcia, Spain.
 *
 *	This file is part of the QVision library.
 *
 *	QVision is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU Lesser General Public License as
 *	published by the Free Software Foundation, version 3 of the License.
 *
 *	QVision is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
 */

/// @file qvcamerawidget.h
/// @brief File from the QVision library.
/// @author PARP Research Group. University of Murcia, Spain.

#ifndef QVCAMERAWIDGET_H
#define QVCAMERAWIDGET_H

#include <QWidget>
#include <QVCamera>
#include <ui/ui_qvcameraform.h>

#ifndef DOXYGEN_IGNORE_THIS
class QVCameraWidget: public QWidget, private Ui::QVCameraForm
	{
	Q_OBJECT
	private:
		QVCamera * camera;
		bool sliderActive;

	public:
		QVCameraWidget(QVCamera *cam, QWidget *parent = 0);

	signals:
		void pause_pressed();
		void unpause_pressed();
		void next_frame_pressed();
		void speed_pressed(double speed);
		void seek_pressed(QVCamera::TSeekType seek_type,double value);
		void close_pressed();

	public slots:
		//void updateVisibleInfo();
		void updateCameraVisibleInfoSlot();
		void updateCameraStateSlot(QVCamera::TCameraStatus);

	private slots:
		void seekPressed();
		void seekReleased();

		//void pausePressed();
		//void unpausePressed();
		//void nextFramePressed();
		void speedPressed();
		void seekMoved();
		//void closePressed();
	};
#endif
#endif
