/*
 *	Copyright (C) 2008. PARP Research Group.
 *	<http://perception.inf.um.es>
 *	University of Murcia, Spain.
 *
 *	This file is part of the QVision library.
 *
 *	QVision is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU Lesser General Public License as
 *	published by the Free Software Foundation, version 3 of the License.
 *
 *	QVision is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef GROUPNODE_H
#define GROUPNODE_H

#include "node.h"

#define SUBSCALE 0.3

#ifndef DOXYGEN_IGNORE_THIS

class GroupNode : public Node
{
public:
    GroupNode(QGraphicsItem * parent = 0, QGraphicsScene * scene = 0);
    ~GroupNode();

    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);
	QPointF scenePointPos(int point) const;
	QPointF scenePointPos(QString name, bool in) const;
    void addNode(Node *node);
	void updateLinksPos();

	QString propName(int point) const; // devuelve el nombre de la propiedad señalada por point

protected:
    void mouseDoubleClickEvent(QGraphicsSceneMouseEvent *event);
    QVariant itemChange(GraphicsItemChange change, const QVariant &value);

private:
    QRectF outlineRect() const;
    int roundness(double size) const;
	int pointAt(QPointF pos) const;
};

#endif
#endif
